//
//  M3XViewController.h
//  microMemex
//
//  Created by narita on 2017/05/10.
//  Copyright © 2017年 narita. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class M3XNote;

@interface M3XViewController : NSViewController <NSBrowserDelegate, NSTextViewDelegate>

#pragma mark - class methods

#pragma mark - init methods

#pragma mark - dealloc

#pragma mark - NSCopying, hash, isEqual:

#pragma mark - NSCoding methods

#pragma mark - restorableState methods

#pragma mark - life cycle methods

#pragma mark - action methods

- (IBAction)new:(id)sender;

- (IBAction)delete:(id)sender;

- (IBAction)browserSelectionDidChange:(id)sender;

#pragma mark - event handling methods

#pragma mark - drawing methods

#pragma mark - delegate/datasource methods

#pragma mark - accessor methods (in pairs)

@property (readwrite, weak  ) IBOutlet NSBrowser*        browserView;
@property (readwrite, weak  ) IBOutlet NSTextView*       textView;

// weakなのは、データ本体はCoreDataが保持しているから
@property (readwrite, strong  ) M3XNote* selectedNode;

// restorableStateのための小細工
@property (readwrite, strong  ) NSIndexPath* selectedIndexPath;

#pragma mark - Utility methods

- (void) trySetBrowserViewSelectionIndexPath:(NSIndexPath*)indexPath;

@end

